* 0078-001-H902 (OSXA)       DRAWING NO. 41285374-001-02
*
*
*
* COMPUTER:  H316, DDP-516
*
*
* PROGRAM CATEGORY:  INPUT/OUTPUT
*
*
* PROGRAM TITLE:  O$XA
*                 TO PLOT ALPHA-NUMERIC AND SPECIAL CHARACTERS ON THE
*                 DIGITAL PLOTTER
*
*
*
*
*
*
*
*
*
*
*                            APPROVAL                          DATE
*
*
*
*                            PROG----------------------    ------------
*
*
*                            SUPR----------------------    ------------
*
*
*                            QUAL----------------------    ------------
*
*
*                                          NO. OF PAGES    ------------
*
*
* AUTHOR
*
* HONEYWELL - COMPUTER CONTROL DIVISION (EUROPE)
*
*
* PURPOSE
*
*    TO PLOT ALPHA-NUMERIC AND SPECIAL CHARACTERS OF VARIABLE SIZE AND
*    AT VARIABLE ANGLE OF INCLINATION ON THE DIGITAL PLOTTER
*
*
* RESTRICTIONS
*
*    THE ROUTINE  WILL WORK ON AN H316 OR DDP-516 COMPUTER WITH A DIGITAL
*    PLOTTER
*
*
* STORAGE
*
*    1520  (OCTAL)
*    848   (DECIMAL)
*
*
* USE
*
*    PLOT A LIST OF ALPHA-NUMERIC AND/OR SPECIAL CHARACTERS
*
*          CALL O$XA (X,Y,HGHT,BCD,THETA,NS)
*
*          OR
*
*          CALL O$XA         PLOT A SYMBOL LIST
*          DAC   X           LOWER LEFT CORNER OF FIRST SYMBOL,X CO-ORD.
*          DAC   Y           LOWER LEFT CORNER OF FIRST SYMBOL,Y CO-ORD.
*          DAC   HGHT        HEIGHT OF THE CHARACTER TO BE DRAWN
*                            IN INCHES OR MILLIMETRES
*          DAC   BCD         LOCATION OF THE ALPHANUMERIC LIST
*                            THIS MAY BE A HOLLERITH STATEMENT
*                            OF THE ACTUAL MESSAGE.
*          DAC   THETA       THE ANGLE OF ORIENTATION OF THE CHARACTERS
*                            MEASURED ANTICLOCKWISE FROM THE X-AXIS
*          DAC   NS          THE NUMBER OF CHARACTERS IN THE LIST
*                            IF NS IS NEGATIVE. A SINGLE SPECIAL
*                            CHARACTER WILL BE PLOTTED AT (X.Y)
*                            AND BCD MUST SPECIFY THE SPECIAL
*                            CHARACTER TO BE USED AS AN INTEGER
*                            WITHIN THE RANGE 1 TO 25. IF NS IS
*                            -1. THE PEN WILL MOVE TO (X,Y) WITH
*                            THE PEN UP AND PLOT THE SYMBOL.
*                            IF NS IS -2. THE PEN WILL MOVE TO
*                            (X,Y) WITH THE PEN DOWN AND PLOT THE
*                            SYMBOL.
*          OCT   0           END OF PARAMETER LIST
*                            NORMAL RETURN
*
*                            N.B. IF (X) OR (Y) ARE ZERO. THEN THE
*                            SYMBOL STRING IS CONTINUED BY USING
*                            THE PREVIOUSLY COMPUTED X AND/OR Y
*                            CO-ORDINATES. TO RETURN THE PEN TO
*                            THE ORIGIN. THE CO-ORDINATES SHOULD
*                            BE SET TO ALMOST ZERO.
*
*    THE SYMBOL SUBROUTINE PLOTS ALL THE STANDARD ISO CHARACTERS FOR THE
*    H316 OR DDP-516 PLUS 25 SPECIAL CHARACTERS. THE FIRST 16 OF WHICH
*    ARE CENTRED. A STRING OF ANY NUMBER OF STANDARD CHARACTERS CAN BE
*    PLOTTED STARTING AT A SPECIFIED POINT AT ANY ANGLE OR HEIGHT. THE
*    STARTING POINT  SPECIFIED WILL BE THE BOTTOM LEFT-HAND CORNER OF THE
*    FIRST CHARACTER. THE CHARACTERS IN THE STRING ARE ASSUMED TO BE
*    IN ISO AND PACKED TWO TO A WORD. THE SPECIAL CHARACTERS ARE PLOTTED
*    ONE AT A TIME.
*
*
* METHOD
*
*    HAVING ESTABLISHED  THE PARAMETERS OF THE CALL, THE PROGRAM STORES
*    THE LIST OF CHARACTERS TO BE PLOTTED. THE PARAMETER LIST, STARTING
*    IN LOCATION (BCD), IS THEN SEARCHED FOR ALPHA-NUMERIC AND SPECIAL
*    CHARACTERS AND EACH SYMBOL HAS A CODE WORD ASSIGNED TO IT. THE
*    PROGRAM SEARCHES THROUGH THE SYMBOL CODE WORD TABLE (TABL) TO
*    DETERMINE:
*
*          1) WHICH PAIR OF OFFSET VALUES IS TO BE PLOTTED FIRST,
*          2) HOW MANY PAIRS ARE TO BE PLOTTED,
*          3) A REFERENCE ADDRESS TO THE OFFSET VALUES TABLE WHICH
*          CONTAINS THE ACTUAL CO-ORDINATES TO BE PLOTTED FOR EACH
*          SYMBOL. USING THESE CO-ORDINATES, MODIFIED FOR OFFSET,
*          THE ROUTINE O$XP IS CALLED TO PLOT EACH PAIR OF
*          CO-ORDINATES.
*
*          NOTE: THE CO-ORDINATE 70 IS A REQUEST TO LIFT THE PEN. AND
*          NOT A  REQUEST TO PLOT AT THIS POINT.
*
*    THE PROGRAM  ALSO CALLS THE FOLLOWING MATH LIBRARY ROUTINES2 D$22,
*    M$22, A$22, S$22, C$12 AND L$22.
*
*
************************************************************************
*
*
\SUBR\O$XA\PLOT ALPHANUMERIC AND SPECIAL CHARACTERS
\SUBR\SYMBOL,O$XA\PLOT ALPHANUMERIC AND SPECIAL CHARACTERS
*
*
\CF5\\H316 AND DDP-516 ONLY
\REL\\RELOCATABLE
*
*
* MAIN PROGRAM
*
* PICK UP  PARAMETERS
O$XA\DAC\**\ENTRY POINT
\STX\SAVX\SAVE INDEX
\CRA
\STA\SPCH\SPECIFIC CHARACTER INDICATOR
\JST\PCUP\PICK UP X PARAMETER
\SNZ\\IS IT ZERO?
\JMP\CONA\YES, USE ORIGINAL X
\STA\XFLO\NO, STORE X PARAMETER - WORD A
\IAB
\STA\XFLO+1\STORE X PARAMETER - WORD B
*
CONA\JST\PCUP\PICK UP Y PARAMETER
\SNZ\\IS IT ZERO
\JMP\CONB\YES, USE ORIGINAL Y
\STA\YFLO\NO, STORE Y PARAMETER - WORD A
\IAB
\STA\YFLO+1\STORE Y PARAMETER - WORD B
*
CONB\JST\PCUP\PICK UP HEIGHT PARAMETER
\STA\HGHT\STORE HEIGHT PARAMETER - WORD A
\IAB
\STA\HGHT+1\STORE HEIGHT PARAMETER - WORD B
*
\LDA*\O$XA\CHARACTER STRING ADDRESS
BACK\SMI\\IS IT INDIRECT?
\JMP\L1\NO. GO SAVE ADDRESS
\CSA\\YES. REMOVE INDIRECT BIT
\STA\0
\LDA\0,1\PICK UP NEW ADDRESS
\JMP\BACK\GO MAKE SURE NOT INDIRECT
L1\STA\BCD\SAVE ADDRESS OF ALPHANUMERIC LIST
\IRS\O$XA\INCREMENT ADDRESS FOR NEXT CHARACTER STRING
*
\JST\PCUP\PICK UP ANGLE PARAMETER
\STA\THTA\STORE ANGLE PARAMETER - WORD A
\IAB
\STA\THTA+1\STORE ANGLE PARAMETER - WORD B
*
\JST\PCUP\PICK UP NUMBER OF CHARACTERS IN THE LABEL
\STA\NS\STORE NUMBER OF CHARACTERS IN THE LABEL
*
* CALCULATE SCALE FACTOR\FACT=HGHT/7.0
ASYM\LDA\HGHT+1\HEIGHT PARAMETER - WORD B
\IAB
\LDA\HGHT\HEIGHT PARAMETER - WORD A
\CALL\D$22\FLOATING POINT DIVIDE
\DAC\SEVN\FLOATING POINT SEVEN
\STA\FACT\SCALE FACTOR - WORD A
\IAB
\STA\FACT+1\SCALE FACTOR - WORD B
*
* TEST FOR SPECIAL CHARACTER
\LDA\NS\NUMBER OF CHARACTERS PARAMETER
\SPL\\IS IT NEGATIVE?
\JMP\SPEC\YES, SPECIAL CHARACTER
\STA\NSCM\NO, NUMBER OF CHARACTERS IN LIST
\JMP\NORM\CONTINUE WITH NORMAL CHARACTER LIST
*
* SPECIAL CHARACTER TREATMENT
SPEC\LDA\=1
\STA\NSCM\ONE SPECIAL CHARACTER
\LDA\='77777
\STA\SPCH\INDICATE SPECIAL CHARACTER
\LDA*\BCD\SYMBOL
\CAS\=15\IS IT TO BE CENTERED?
\JMP\SPCA\NO
\NOP\\YES
*
* CALCULATE SCALE FACTOR FOR CENTRALISED SPECIAL CHARACTER
\LDA\HGHT+1\SYMBOL HEIGHT - WORD B
\IAB
\LDA\HGHT\SYMBOL HEIGHT - WORD A
\CALL\D$22\FLOATING POINT DIVIDE
\DAC\FOUR\FLOATING POINT FOUR
\STA\FACT\FACTOR=HGHT/4.0 - WORD A
\IAB
\STA\FACT+1\FACTOR - WORD B
*
* SET PEN READY TO PLOT SPECIAL CHARACTER
SPCA\LDA\NS\NUMBER OF CHARACTERS
\CAS\=-2\PEN DOWN?
\JMP\NORM\NO
\JMP\L2\NS=-2, REQUIRES PEN DOWN
\JMP\NORM\NO
L2\LDA\=2\PUT PEN DOWN
\JMP\IND\GO INDICATE PEN DOWN
NORM\LDA\=3\PUT PEN UP
IND\STA\IC\PEN POSITION INDICATOR
*
* CONVERT THE ANGLE TO RADIANS
\LDA\THTA+1\ORIENTATION ANGLE - WORD B
\IAB
\LDA\THTA\ORIENTATION ANGLE - WORD A
\CALL\D$22\CONVERT DEGREES TO RADIANS
\DAC\RADN\CONVERSION FACTOR
\STA\RTHT\ANGLE IN RADIANS - WORD A
\IAB
\STA\RTHT+1\ANGLE IN RADIANS - WORD B
*
* CALCULATE THE SINE POLAR OFFSET FACTOR
\CALL\SIN\SINE ROUTINE
\DAC\RTHT\SIN THETA
\CALL\M$22\FLOATING POINT MULTIPLY
\DAC\FACT\(HGHT/4.0) OR (HGHT/7.0)
\STA\INCS\POLAR OFFSET FACTOR (SINE) - WORD A
\IAB
\STA\INCS+1\POLAR OFFSET FACTOR (SINE) - WORD B
*
* CALCULATE OFFSET Y VALUE\YT=INCS*6.0
\IAB\\BRING BACK INCS
\CALL\M$22\FLOATING POINT MULTIPLY
\DAC\SSIX\FLOATING POINT SIX
\STA\YT\OFFSET Y - WORD A
\IAB
\STA\YT+1\OFFSET Y - WORD B
*
* CALCULATE THE COSINE POLAR OFFSET FACTOR
\CALL\COS\COSINE ROUTINE
\DAC\RTHT\ANGLE IN RADIANS
\CALL\M$22\FLOATING POINT MULTIPLY
\DAC\FACT\(HGHT/4.0) OR (HGHT/7.0)
\STA\INCC\POLAR OFFSET FACTOR (COSINE) - WORD A
\IAB
\STA\INCC+1\POLAR OFFSET FACTOR (COSINE) - WORD B
*
* CALCULATE OFFSET X VALUE\XT=INCC*6.0
\IAB\\BRING BACK INCC
\CALL\M$22\FLOATING POINT MULTIPLY
\DAC\SSIX\FLOATING POINT SIX
\STA\XT\OFFSET X - WORD A
\IAB
\STA\XT+1\OFFSET X - WORD B
*
* SET UP NUMBER OF SYMBOLS IN CURRENT WORD
\LDA\=-2
\STA\SCWM\NO. OF SYMBOLS IN CURRENT WORD T
\LDA*\BCD\FIRST WORD OF CHARACTER LIST
\STA\SBCD\STORE ITS ADDRESS
\IAB
\LDA\SPCH\SPECIAL CHARACTER INDICATOR
\SZE\\IS IT ZERO?
\JMP\MORE\NO. SPECIAL CHARACTER
*
* GET CURRENT G-BIT CHARACTER TO PLOT
LOC\LDA\SBCD\CURRENT SYMBOL WORD
\LLR\8\TAKE LEAST SIGNIFICANT HALF
\STA\SBCD\BALANCE OF MESSAGE WORD
\IAB\\BRING BACK MOST SIGNIFICANT HALF
\ANA\='77\CONSIDER L.S. SIX BITS
\STA\CSMS\CURRENT SIX BIT CHARACTER TO PLOT
\ALS\1\TIMES TWO
\STA\0\TO INDEX
*
* PICK UP SYMBOL CODE WORD AND OFFSET ADDRESS
LOCA\LDA\TABL,1\SYMBOL CODE WORD TABLE
\STA\CDWS\FIRST WORD OF PAIR
\LDA\TABL+1,1\OFFSET VALUES ADDRESS
\STA\CDWS+1\SECOND WORD OF PAIR
\LDA*\CDWS+1\GET CURRENT OFFSET WORD
\STA\WOFW\CURRENT OFFSET WORD
*
* EXAMINE NUMBER OF OFFSET PAIRS
\LDA\CDWS\OFFSET VALUE CODE WORD
\ANA\='77\CONSIDER L.S SIX BITS
\STA\NMBT\NUMBER OF OFFSET PAIRS
\SNZ\\IS IT ZERO?
\JMP\CLAP\YES, NO OFFSET PAIRS, GO PUT PEN UP
\LDA\SPCH\NO, GET SPECIAL CHARACTER INDICATOR
\SZE\\IS CURRENT SYMBOL A SPECIAL CHARACTER?
\JMP\SPZR\YES, GIVE SPECIAL CHARACTER TREATMENT
SPZS\LDA\CDWS\NO, TAKE OFFSET PAIR
\LGR\6\EXAMINE FOR SHIFT INSTRUCTION CHOICE
\STA\0\PUT SHIFT VALUE IN X-REGISTER
FRED\LDA\SHFT-1,1\SHIFT INSTRUCTION CHOICE
\STA\SKIP\ALS 4 OR ALS 10
\LDA\WOFW\CURRENT OFFSET WORD
SKIP\***\**\SHIFT INSTRUCTION
\STA\WOFW\SHIFTED TO BITS 1 TO 6
\LDA\0\X-REGISTER
\ADD\=-3
\STA\SWPW\NUMBER OF SETS REMAINING IN THIS WORD
*
* EXAMINE VALUE OF CURRENT PAIR
DLOC\LDA\WOFW\CURRENT OFFSET WORD
\LLR\6\FIRST PAIR
\STA\WOFW\RESTORE BALANCE
\IAB\\BRING BACK FIRST PAIR
\ANA\='77\EXAMINE L.S. SIX BITS
\STA\OFFW\CURRENT PAIR
\LRL\3\EXAMINE VALUE OF CURRENT PAIR
*
* IF VALUE >6 PEN MUST BE LIFTED
\CAS\=6
\JMP\L3\VALUE>6. GO LIFT PEN
\JMP\SYMD\VALUE=6. GO PLOT POINT
\JMP\SYMD\VALUE<6. GO PLOT POINT
*
L3\LDA\=3\INDICATE PEN UP
STDA\STA\IC\PEN POSITION INDICATOR
*
* GET NEXT OFFSET PAIR
\LDA\NMBT\NUMBER OF OFFSET PAIRS
\ADD\=-1\TEST FOR END OF SYMBOL PLOT
\SNZ
\JMP\CLAP\GO FOR NEXT SYMBOL
\STA\NMBT\REMAINING NUMBER OF OFFSET PAIRS
*
\IRS\SWPW\IS IT LAST PAIR OF THIS WORD?
\JMP\DLOC\NO, CONTINUE EXAMINING OFFSET PAIR
\LDA\=-2
\STA\SWPW\REMAINING SETS THIS WORD
\IRS\CDWS+1\ADDRESS OF NEXT SYMBOL CODE WORD
\LDA*\CDWS+1\NEXT SYMBOL CODE WORD
\STA\WOFW\NEW OFFSET WORD
\LDX\=1\RESET X-REGISTER
\JMP\FRED\GO EXAMINE NEW OFFSET WORD
*
*
* SPECIAL CHARACTER TREATMENT
MORE\IAB\\BRING BACK FIRST WORD OF CHARACTER LIST
\STA\0\TO INDEX
\CAS\=15\IS SYMBOL TO BE CENTERED?
\JMP\L4\NO.
\JMP\LOCB\YES, GO AND ADD CENTERING FACTOR
\JMP\LOCB\YES, GO AND ADD CENTERING FACTOR
*
L4\CRA
\STA\SPCH\CLEAR SPECIAL CHARACTER INDICATOR
\LDA\SBCD\NEXT CURRENT SYMBOL WORD
\CAS\=24\IS IT A SPECIAL CHARACTER?
\JMP\L5\YES, GO LOOK AT SIX BIT CHARACTER TO PLOT
\JMP\LOCB\NO, GO TREAT THIS AS NORMAL CHARACTER
\JMP\LOCB\NO, GO TREAT THIS AS NORMAL CHARACTER
*
L5\ANA\='77\EXAMINE L.S. SIX BITS
L9\ALS\1\TIMES TWO
LOCZ\STA\0\TO INDEX
\STA\CSMS\CURRENT SIX BIT CHARACTER TO PLOT
\JMP\LOCA\GO LOOK UP NEXT SYMBOL CODE WORD
*
LOCB\ADD\='100\ADD T0 CURRENT SYMBOL WORD
\JMP\L9\RETURN TO LOOK UP SYMBOL CODE WORD
*
* CALCULATE THE COORDINATES TO PLOT THE SYMBOL
CLAP\LDA\=3\INDICATE PEN UP
\STA\IC\PEN POSITION INDICATOR
\LDA\XFLO+1\X PARAMETER - WORD B
\IAB
\LDA\XFLO\X PARAMETER - WORD A
\CALL\A$22\FLOATING POINT ADD
\DAC\XT\OFFSET FOR X
\STA\XFLO\OFFSET X PARAMETER - WORD A
\IAB
\STA\XFLO+1\OFFSET X PARAMETER - WORD B
*
\LDA\YFLO+1\Y PARAMETER - WORD B
\IAB
\LDA\YFLO\Y PARAMETER - WORD A
\CALL\A$22\FLOATING POINT ADD
\DAC\YT\OFFSET FOR Y
\STA\YFLO\OFFSET Y PARAMETER - WORD A
\IAB
\STA\YFLO+1\OFFSET Y PARAMETER - WORD B
*
* HAS THE END OF THE ALPHANUMERIC LIST BEEN REACHED?
\IRS\SCWM\TALLY SYMBOL COUNT
\JMP\SYME\NOT END OF LIST, CHECK NO. OF CHARACTERS
\LDA\=-2
\STA\SCWM\SYMBOL COUNT FOR NEXT WORD
\IRS\BCD\TALLY ADDRESS OF ALPHANUMERIC LIST
\LDA*\BCD\ALPHANUMERIC LIST
\STA\SBCD\NEXT CURRENT SYMBOL WORD
*
SYME\LDA\NSCM\NUMBER OF CHARACTERS
\ADD\=-1\DECREASE BY ONE
\STA\NSCM\NUMBER OF CHARACTERS
\SZE\\END OF CHARACTER LIST?
\JMP\LOC\GO AND PROCESS NEXT CHARACTER ON LIST
\LDX\SAVX\RESTORE INDEX
\IRS\O$XA\INCREMENT EXIT
\JMP*\O$XA\EXIT
*
* SPECIAL CHARACTER TREATMENT
*
* OFFSET FLOATING POINT X VALUE - XFLO=XFLO+2.0*(INCS-INCC)
SPZR\LDA\INCS+1\POLAR OFFSET FACTOR (SINE) - WORD B
\IAB
\LDA\INCS\POLAR OFFSET FACTOR (SINE) - WORD A
\CALL\S$22\FLOATING POINT SUBTRACT
\DAC\INCC\POLAR OFFSET FACTOR (COSINE)
\CALL\M$22\FLOATING POINT MULTIPLY
\DAC\TWOO\FLOATING POINT TWO
\STA\CAMP\RESULT =2.0*(INCS-INCC) - WORD A
\IAB
\STA\CAMP+1\RESULT =2.0*(INCS-INCC) - WORD B
*
\LDA\XT+1\OFFSET X - WORD B
\IAB
\LDA\XT\OFFSET X - WORD A
\CALL\S$22\FLOATING POINT SUBTRACT
\DAC\CAMP\2.0*(INCS-INCC)
\STA\XT\OFFSET X - WORD A   XT=XT-2.0*(INCS-INCC)
\IAB
\STA\XT+1\OFFSET X - WORD B
\LDA\CAMP+1\2.0*(INCS-INCC) - WORD B
\IAB
\LDA\CAMP\2.0*(INCS-INCC) - WORD A
\CALL\A$22\FLOATING POINT ADDITION
\DAC\XFLO\FLOATING POINT X PARAMETER
\STA\XFLO\OFFSET FLOATING POINT X VALUE - WORD A
\IAB
\STA\XFLO+1\OFFSET FLOATING POINT X VALUE - WORD B
*
* OFFSET FLOATING POINT Y VALUE - YFLO=YFLO-2.0*(INCC+INCS)
\LDA\INCC+1\POLAR OFFSET FACTOR (COSINE) - WORD B
\IAB
\LDA\INCC\POLAR OFFSET FACTOR (COSINE) - WORD A
\CALL\A$22\FLOATING POINT ADDITION
\DAC\INCS\POLAR OFFSET FACTOR (SINE)
\CALL\M$22\FLOATING POINT MULTIPLY
\DAC\TWOO\FLOATING POINT TWO
\STA\CAMP\RESULT - WORD A
\IAB
\STA\CAMP+1\RESULT - WORD B
\LDA\YFLO+1\FLOATING POINT Y PARAMETER - WORD B
\IAB
\LDA\YFLO\FLOATING POINT Y PARAMETER - WORD A
\CALL\S$22\FLOATING POINT SUBTRACT
\DAC\CAMP\RESULT
\STA\YFLO\OFFSET FLOATING POINT Y VALUE - WORD A
\IAB
\STA\YFLO+1\OFFSET FLOATING POINT Y VALUE - WORD B
\LDA\CAMP+1\RESULT - WORD B
\IAB
\LDA\CAMP\RESULT - WORD A
\CALL\A$22\FLOATING POINT ADDITION
\DAC\YT\OFFSET Y
\STA\YT\OFFSET Y - WORD A   YT=YT+2.0*(INCC+INCS)
\IAB
\STA\YT+1\OFFSET Y - WORD B
\JMP\SPZS\GO AND PLOT THIS SYMBOL
*
* PLOT THE CURRENT SYMBOL
SYMD\LDX\=-4\X-REGISTER FOR COUNT OF 4
L6\LDA\XFLO+4,1\FLOATING POINT X & Y VALUES
\STA\XX+4,1\TEMPORARY FLOATING POINT X & Y VALUES
\IRS\0\TALLY COUNT
\JMP\L6\RETURN FOR NEXT VALUE
\LDA\OFFW\CURRENT PAIR TO PLOT
\LRL\3\TAKE X PART OF PAIR
\CALL\C$12\FIXED TO FLOATING
\STA\OFFX\X PART OF CURRENT PAIR - WORD A
\IAB
\STA\OFFX+1\X PART OF CURRENT PAIR - WORD B
*
\LDA\OFFW\CURRENT PAIR TO PLOT
\ANA\='7\TAKE Y PART OF PAIR
\CALL\C$12\FIXED TO FLOATING
\STA\OFFY\Y PART OF CURRENT PAIR - WORD A
\IAB
\STA\OFFY+1\Y PART OF CURRENT PAIR - WORD B
*
* CALCULATE ACTUAL COORDINATES FOR PLOTTING
*
* XX=XX+(OFFX*INCC)-(OFFY*INCS)
\IAB\\BRING BACK OFFY
\CALL\M$22\FLOATING POINT MULTIPLY
\DAC\INCS\POLAR OFFSET FACTOR (SINE)
\STA\CAMP\RESULT - WORD A
\IAB
\STA\CAMP+1\RESULT - WORD B
*
\LDA\OFFX+1\X PART OF CURRENT PAIR - WORD B
\IAB
\LDA\OFFX\X PART OF CURRENT PAIR - WORD A
\CALL\M$22\FLOATING POINT MULTIPLY
\DAC\INCC\POLAR OFFSET FACTOR (COSINE)
\CALL\A$22\FLOATING POINT ADDITION
\DAC\XX\FLOATING POINT X VALUE
\CALL\S$22\FLOATING POINT SUBTRACT
\DAC\CAMP\RESULT
\STA\XX\X CO-ORDINATE TO PLOT - WORD A
\IAB
\STA\XX+1\X CO-ORDINATE TO PLOT - WORD B
*
* YY=YY+(OFFX*INCS)+(OFFY*INCC)
\LDA\OFFY+1\Y PART OF CURRENT PAIR - WORD B
\IAB
\LDA\OFFY\Y PART OF CURRENT PAIR - WORD A
\CALL\M$22\FLOATING POINT MULTIPLY
\DAC\INCC\POLAR OFFSET FACTOR (COSINE)
\STA\CAMP\RESULT - WORD A
\IAB
\STA\CAMP+1\RESULT - WORD B
*
\LDA\OFFX+1\X PART OF CURRENT PAIR - WORD B
\IAB
\LDA\OFFX\X PART OF CURRENT PAIR - WORD A
\CALL\M$22\FLOATING POINT MULTIPLY
\DAC\INCS\POLAR OFFSET FACTOR (SINE)
\CALL\A$22\FLOATING POINT ADDITION
\DAC\YY\FLOATING POINT Y VALUE
\CALL\A$22\FLOATING POINT ADDITION
\DAC\CAMP\RESULT
\STA\YY\Y CO-ORDINATE TO PLOT - WORD A
\IAB
\STA\YY+1\Y CO-ORDINATE TO PLOT - WORD B
*
\CALL\O$XP\PLOT A LINE
\DAC\XX\X CO-ORDINATE
\DAC\YY\Y CO-ORDINATE
\DAC\IC\PEN POSITION INDICATOR
\HLT\\END OF PARAMETER LIST
*
\LDA\=2\INDICATE PEN DOWN
\JMP\STDA\RETURN FOR NEXT POINT
*
*
* SUBROUTINES
*
* PICK UP A FLOATING POINT PARAMETER
PCUP\DAC\**\ENTRY POINT
\LDA*\O$XA\PARAMETER ADDRESS
\STA\PCUA\PARAMETER VALUE
\CALL\L$22\FLOATING POINT LOAD
PCUA\***\**\PARAMETER VALUE
\IRS\O$XA\TALLY PARAMETER ADDRESS
\JMP*\PCUP\EXIT
*
*
* VARIABLES
*
HGHT\BSZ\2\HEIGHT OF SYMBOL
THTA\BSZ\2\ANGLE OF INCLINATION OF SYMBOL
XFLO\BSZ\2\FLOATING POINT X PARAMETER
YFLO\BSZ\2\FLOATING POINT Y PARAMETER
XX\BSZ\2\X CO-ORDINATE TO PLOT
YY\BSZ\2\Y CO-ORDINATE TO PLOT
FACT\BSZ\2\SCALE FACTOR
RTHT\BSZ\2\ANGLE IN RADIANS
INCS\BSZ\2\POLAR OFFSET FACTOR (SINE)
INCC\BSZ\2\POLAR OFFSET FACTOR (COSINE)
XT\BSZ\2\OFFSET X
YT\BSZ\2\OFFSET Y
OFFX\BSZ\2\X PART OF CURRENT PAIR
OFFY\BSZ\2\Y PART OF CURRENT PAIR
CAMP\BSZ\2\RESULT
CDWS\BSZ\2\OFFSET VALUE CODE WORD
*
BCD\BSZ\1\SYMBOL LOCATION
NS\BSZ\1\NUMBER OF CHARACTERS PARAMETER
IC\BSZ\1\PEN POSITION INDICATOR
SPCH\BSZ\1\OPECIAL CHARACTER INDICATOR
NSCM\BSZ\1\NUMBER OF CHARACTERS IN LIST
SCWM\BSZ\1\NO. OF SYMBOLS IN CURRENT WORD
CSMS\BSZ\1\CURRENT SIX BIT CHARACTER TO PLOT
NMBT\BSZ\1\REMAINING NUMBER OF OFFSET PAIRS
SWPW\BSZ\1\REMAINING SETS THIS WORD
WOFW\BSZ\1\NEW OFFSET WORD
OFFW\BSZ\1\CURRENT PAIR
SBCD\BSZ\1\BALANCE OF MESSAGE
SAVX\BSZ\1\INDEX
*
*
* CONSTANTS
*
TWOO\DEC\.2E1\2.0
FOUR\DEC\.4E1\4.0
SSIX\DEC\.6E1\6.0
SEVN\DEC\.7E1\7.0
RADN\DEC\57.29577\DEGREES TO RADIANS CONVERSION FACTOR
SHFT\ALS\4\SHIFT INSTRUCTION
\ALS\10\SHIFT INSTRUCTION
*
*
* SYMBOL CODE WORD TABLE
TABL\OCT\215\6
\DAC\AT
\OCT\111\A
\DAC\A
\OCT\214\B
\DAC\D
\OCT\110\C
\DAC\G
\OCT\110\D
\DAC\D
\OCT\107\E
\DAC\E
\OCT\206\F
\DAC\E
\OCT\112\G
\DAC\G
\OCT\106\H
\DAC\N+1
\OCT\206\I
\DAC\I
\OCT\105\J
\DAC\U+1
\OCT\206\K
\DAC\K
\OCT\103\L
\DAC\E
\OCT\205\M
\DAC\M
\OCT\104\N
\DAC\N
\OCT\114\O
\DAC\O
\OCT\207\P
\DAC\R
\OCT\114\Q
\DAC\Q
\OCT\212\R
\DAC\R
\OCT\214\S
\DAC\S
\OCT\104\T
\DAC\T
\OCT\206\U
\DAC\U
\OCT\103\V
\DAC\V\MY SOURCE CODE (-02) HAD 'T' HERE, NOT V
\OCT\205\W
\DAC\W
\OCT\207\X
\DAC\X
\OCT\205\Y
\DAC\Y
\OCT\204\Z
\DAC\Z
\OCT\104\[
\DAC\OSB
\OCT\102\BACK SLASH
\DAC\U
\OCT\104\]
\DAC\SQB
\OCT\205\^
\DAC\UP
\OCT\105\LEFT ARROW
\DAC\LEFT
\OCT\101\SPACE
\DAC\U
\OCT\205\EXCLAMATION MARK
\DAC\EX
\OCT\205\"
\DAC\QUOT
\OCT\121\POUND SIGN
\DAC\PND
\OCT\115\$
\DAC\T+1
\OCT\216\%
\DAC\PER
\OCT\111\&
\DAC\AND
\OCT\102\'
\DAC\APOS
\OCT\104\(
\DAC\LB
\OCT\104\)
\DAC\RB
\OCT\110\*
\DAC\STAR
\OCT\105\+
\DAC\PLUS
\OCT\106\,
\DAC\COM
\OCT\102\-
\DAC\MNUS
\OCT\105\.
\DAC\STOP
\OCT\102\/
\DAC\R
\OCT\111\0
\DAC\O
\OCT\105\1
\DAC\ONE
\OCT\210\2
\DAC\TWO
\OCT\115\3
\DAC\VIII
\OCT\206\4
\DAC\IV
\OCT\211\5
\DAC\E+1
\OCT\214\6
\DAC\SIX
\OCT\106\7
\DAC\VII
\OCT\121\8
\DAC\VIII
\OCT\114\9
\DAC\NINE
\OCT\113\:
\DAC\SCOL
\OCT\114\;
\DAC\SCOL
\OCT\103\<
\DAC\LT
\OCT\205\=
\DAC\EQ
\OCT\103\>
\DAC\GT
\OCT\113\?
\DAC\QUST
*
* SPECIAL SYMBOL CODE WORD TABLE
\OCT\210\00
\DAC\S1
\OCT\114\01
\DAC\S2
\OCT\206\02
\DAC\S3
\OCT\107\03
\DAC\S4
\OCT\107\04
\DAC\S5
\OCT\207\05
\DAC\S6
\OCT\207\06
\DAC\S7
\OCT\106\07
\DAC\S8
\OCT\210\08
\DAC\S9
\OCT\107\09
\DAC\S10
\OCT\116\10
\DAC\S11
\OCT\115\11
\DAC\S4
\OCT\206\12
\DAC\S13
\OCT\204\13
\DAC\S4+1
\OCT\215\14
\DAC\S6
\OCT\104\15
\DAC\S4
\OCT\202\16
\DAC\VECT+1
\OCT\105\17
\DAC\DAR\DOWN ARROW
\OCT\110\18
\DAC\MNUS
\OCT\205\19
\DAC\AR\RIGHT ARROW
\OCT\106\20
\DAC\GREQ
\OCT\103\21
\DAC\AST
\OCT\210\22
\DAC\NOEQ
\OCT\210\23
\DAC\PMI
\OCT\106\24
\DAC\LEEQ
*
* OFFSET VALUES TABLE
A\OCT\0004,4404,0617,3746
E\OCT\4000,0747,0704,3443
\OCT\4130
S\OCT\1001,1030,4143,3414
TWO\OCT\0506,1737,4645,0100
U\OCT\4007,0110,3041
N\OCT\4740,0700,0444
Z\OCT\4740,0047
T\OCT\0747,2720,7002,1131
\OCT\4233,1405,1636
M\OCT\4500,0724
K\OCT\4740,0400,0704
R\OCT\4700,0737,4645,3404
\OCT\3443
AND\OCT\4015,2635,0201,1020
LT\OCT\4204
G\OCT\4637,1706,0110,3041
\OCT\4333
SQB\OCT\1040,4717
\OCT\4333
X\OCT\4707,2400,2440,2447
GT\OCT\0244
VIII\OCT\0617,3746,4534,1434
\OCT\4341,3010,0103,1405
VII\OCT\0607,4746
IV\OCT\2120,4030,3702
QUOT\OCT\4217,1570,3537
APOS\OCT\2527
ONE\OCT\1627,2010
AT\OCT\3031,3313,1131,4043
\OCT\3414,0301
Y\OCT\1020,2407,2447
RB\OCT\1726
I\OCT\2110,3020,2717
LB\OCT\3726,2130
MNUS\OCT\0444
EQ\OCT\7045,0570,0343
\OCT\0106,1737
SIX\OCT\3603,1434,4341,3010
\OCT\0106,1737
D\OCT\4641,3000,0737,4645
\OCT\3404,3443
Q\OCT\4130,1001,0617,3746
\OCT\4170,4022
SCOL\OCT\2414,1525,2470
COM\OCT\2111,1222
EX\OCT\2120,2170,2227
STOP\OCT\2120,1011,2101
PLUS\OCT\2125,2303,4323,0541
V\OCT\0720
W\OCT\4707,1024,3047
NINE\OCT\0110,3041,4637,1706
\OCT\0413,3344
QUST\OCT\0617,3746,4534,2422
\OCT\7021
UP\OCT\2021,2615,3526
LEFT\OCT\0415,1304
PER\OCT\4417,0706,1617,7047
\OCT\0070,4030,3141
S1\OCT\4022,2404,0040,4424
S2\OCT\2224,1403,0110,3041
\OCT\4334
S3\OCT\2422,2401,4124
S4\OCT\2242,0222,2024
S5\OCT\2244,0022,0440
S8\OCT\2200,4404
S6\OCT\4022,2402,2042
S7\OCT\2422,2024,0242
S9\OCT\2422,4404,4400,4000
S10\OCT\2204,2244,2220
S11\OCT\2244,3313,0413,1100
\OCT\1131,4031
S13\OCT\3322,4404,4000
S15\OCT\2210,3650,0464
VECT\OCT\1022,6222,2625
DAR\OCT\2720,1131
AR\OCT\2003,4334,3243
GREQ\OCT\0644,0270
LEEQ\OCT\0141,7042,0446
AST\OCT\0125
NOEQ\OCT\4145,0570,2226,2404
PMI\OCT\4401,4170,2226,2404
\OCT\4400
O\OCT\4130,1001,0617,3746
\OCT\4170,0047
OSB\OCT\3000,0737
STAR\OCT\2126,7005,4270,4502
PND\OCT\4130,2011,0100,1016
\OCT\2737,4670,0323,7024
\OCT\0400
*
* LITERALS
*
\FIN\\LITERALS
*
*
*
\END\O$XA\END OF O$XA 16.JUL.70 HAD
