* 0078-001-H908 (O$XP)       DRAWING NO. 41285371-301-02
*
*
*
* COMPUTER:  H316, DDP-516
*
*
* PROGRAM CATEGORY:  INPUT/OUTPUT
*
*
* PROGRAM TITLE:  O$XP
*                 CONTROL THE MOTION OF THE DIGITAL PLOTTER EOM 2113
*
*
*
*
*
*
*
*
*
*
*
*                            APPROVAL                          DATE
*
*
*
*                            PROG----------------------    ------------
*
*
*                            SUPR----------------------    ------------
*
*
*                            QUAL----------------------    ------------
*
*
*                                          NO. OF PAGES    ------------
*
*
* AUTHOR
*
*    HONEYWELL - COMPUTER CONTROL DIVISION (EUROPE)
*
*
* PURPOSE
*
*    TO CONTROL THE MOTION OF THE DIGITAL PLOTTER EOM 2113
*
*
* RESTRICTIONS
*
*    THE PROGRAM WILL OPERATE ON AN H316 OR DDP-516 COMPUTER WITH A
*    DIGITAL PLOTTER EOM 2113
*
*
* STORAGE
*
*    542  (OCTAL)
*    354  (DECIMAL)
*
*
* USE
*
*    PLOT A LINE
*
*          CALL O$XP (X,Y,IC)
*
*          OR
*
*          CALL O$XP         PLOT A LINE
*          DAC  X            PEN POSITION, X CO-ORDINATE
*          DAC  Y            PEN POSITION, Y CO-ORDINATE
*          DAC  IC           PEN POSITION INDICATOR
*          OCT  0            END OF PARAMETER LIST
*                            NORMAL RETURN
*
*          PLOT IS AN IDENTICAL ENTRY TO O$XP
*
*    PROVIDE OFFSET DISTANCES AND SCALE FACTORS
*
*          CALL O$XO (XMIN,XFAC,YMIN,YFAC)
*
*          OR
*
*          CALL O$XO         PROVIDE OFFSET DISTANCES AND SCALE FACTORS
*          DAC  XMIN         DISTANCE TO TRANSLATE ORIGIN ALONG X AXIS
*          DAC  XFAC         SCALE VALUE FOR X AXIS
*          DAC  YMIN         DISTANCE TO TRANSLATE ORIGIN ALONG Y AXIS
*          DAC  YFAC         SCALE VALUE FOR Y AXIS
*          OCT  0            END OF PARAMETER LIST
*                            NORMAL RETURN
*
*          OFFSET IS AN IDENTICAL ENTRY TO O$XO
*
*    PROVIDE THE SCALE VALUE FOR BOTH AXES
*
*          CALL O$XF (FACT)
*
*          OR
*
*          CALL O$XF         PROVIDE THE SCALE VALUE FOR BOTH AXES
*          DAC  FACT         SCALE VALUE
*                            NORMAL RETURN
*
*          FACTOR IS AN IDENTICAL ENTRY TO O$XF
*
*    REQUEST PRESENT PEN POSITION AND SCALE VALUE
*
*          CALL O$XW (X,Y,FACT)
*
*          OR
*
*          CALL O$XW         PRESENT PEN POSITION AND SCALE VALUE
*          DAC  X            PRESENT PEN POSITION, X CO-ORDINATE
*          DAC  Y            PRESENT PEN POSITION, Y CO-ORDINATE
*          DAC  FACT         CURRENT SCALE VALUE
*          OCT  0            END OF PARAMETER LIST
*                            NORMAL RETURN
*
*          WHERE IS AN IDENTICAL ENTRY TO O$XW
*
*    SET PEN AT ORIGIN
*
*          CALL O$XG
*   '
*          OR
*
*          CALL O$XG         SET PEN AT ORIGIN
*                            NORMAL RETURN
*
*          ORIGIN IS AN IDENTICAL ENTRY TO O$XG
*
*
* METHOD
*
*    A CALL ON THE O$XP ROUTINE WILL MOVE THE PEN FROM ITS PRESENT
*    POSITION (GIVEN BY THE O$XW ROUTINE) TO THE POINT SPECIFIED IN THE
*    CALL.  THE MOVE WILL BE MADE WITH THE PEN DOWN IF IC=2 OR UP IF
*    IC=3. IF IC IS NEGATIVE THE PLOT WILL BE ENDED AFTER THE MOVE IS
*    MADE AND CONTROL RETURNED TO THE CALLING PROGRAM. IF IC=12 OR 13
*    THE INPUTS FROM THE O$XO ENTRANCE WILL BE USED.
*
*    A CALL ON THE O$XO ROUTINE WILL CAUSE THE ORIGIN AND ITS AXES TO BE
*    OFFSET TO THE POINT CALLED. WITH SCALES AS SPECIFIED. SUBSEOUENT
*    PLOTS WILL REFER TO THIS NEW ORIGIN.
*
*    THE O$XF ROUTINE PROVIDES THE SCALE FOR BOTH AXES. WHETHER OFFSET
*    OR BASED ON THE ORIGIN.
*
*    THE O$XG ROUTINE MOVES THE PEN WEST 360 MILLIMETRES AND BACK EAST
*    TO WITHIN 10 MILLIMETRES OF THE EDGE OF THE PAPER. THIS IS TAKEN
*    AS THE ORIGIN (0,0).
*
*    THESE ROUTINES ALSO CALL THE FOLLOWING MATH LIBRARY ROUTINES: S$22,
*    D$22, M$22, C$21 AND H$22.
*
*
************************************************************************
*
*
\SUBR\O$XP\PLOT A LINE
\SUBR\PLOT,O$XP\PLOT A LINE
\SUBR\O$XO\PROVIDE OFFSET DISTANCES AND SCALE FACTORS
\SUBR\OFFSET,O$XO\PROVIDE OFFSET DISTANCES AND SCALE FACTORS
\SUBR\O$XF\PROVIDE SCALE VALUE FOR BOTH AXES
\SUBR\FACTOR,O$XF\PROVIDE SCALE VALUE FOR BOTH AXES
\SUBR\O$XW\REQUEST PRESENT PEN POSITION
\SUBR\WHERE,O$XW\REQUEST PRESENT PEN POSITION
\SUBR\O$XG\SET PEN AT ORIGIN
\SUBR\ORIGIN,O$XG\SET PEN AT ORIGIN
*
*
\CF5\\H316 OR DDP-516
\REL\\RELOCATABLE
*
*
* PLOTTER  DEVICE CODES
*
* OCP
DADP\EQU\'0027\DEVICE ADDRESS OF DIGITAL PLOTTER
PNDN\EQU\DADP+'1400\PUT PEN DOWN
PNUP\EQU\DADP+'1600\PUT PEN UP
*
* SKS
SKNB\EQU\DADP+'100\SKIP IF NOT BUSY
SKLM\EQU\DADP+'200\SKIP IF LIMIT OF TRAVEL NOT REACHED
*
*
* PLOT  A LINE
*
O$XP\DAC\**\PLOT A LINE
\STX\SAVE\SAVE INDEX
\LDA*\O$XP\ADDRESS OF X
\IRS\O$XP\ADDRESS OF NEXT PARAMETER
\JST\PCUP\PICK UP X
\STA\XFLT\FLOATING POINT X VALUE - WORD A
\STA\XFX\FLOATING POINT X POSITION - WORD A
\IAB
\STA\XFLT+1\FLOATING POINT X VALUE - WORD B
\STA\XFX+1\FLOATING POINT X POSITION - WORD B
*
\LDA*\O$XP\ADDRESS OF Y
\IRS\O$XP\ADDRESS OF NEXT PARAMETER
\JST\PCUP\PICK UP Y
\STA\YFLT\FLOATING POINT Y VALUE - WORD A
\STA\YFY\FLOATING POINT Y POSITION - WORD A
\IAB
\STA\YFLT+1\FLOATING POINT Y VALUE - WORD B
\STA\YFY+1\FLOATING POINT Y POSITION - WORD B
*
\LDA*\O$XP\ADDRESS OF PEN POSITION INDICATOR
\JST\PCUP\PICK UP INDICATOR
PLTA\STA\IC\PEN POSITION INDICATOR PARAMETER
\SPL\\IS IT POSITIVE?
\TCA\\NO, NEGATE IT
\SUB\=10\YES, SUBTRACT 10
\SPL\\IS IC>10?
\ADD\=10\RESTORE PEN POSITION INDICATOR
\STA\IP\NO. RESTORE TO PREVIOUS VALUE
\CAS\=3\IS IC=3?
\JMP\ERPN\IC>3, PEN CONTROL ERROR
\JMP\PEN3\IC=3, GO AND PUT PEN UP
\CAS\=2\IS IC=2?
\JMP\ERPN\NO, PEN CONTROL ERROR
\JMP\PEN2\IC=2, GO AND PUT PEN DOWN
*
ERPN\LDA\PNER\PEN CONTROL ERROR
\JMP\PLTA\PEN NOW DOWN
*
* PUT PEN DOWN ROUTINE
PEN2\LDA\PENP\PEN POSITION INDICATOR
\SZE\\IS IT ZERO?
\JMP\CFOF\NO, GO GET INDICATOR PARAMETER
\SKS\SKNB\SKIP IF NOT BUSY
\JMP\*-1\WAIT UNTIL NOT BUSY
\OCP\PNDN\PUT PEN DOWN
\LDA\=-1\INDICATE PEN DOWN
\JMP\PENC\SET PEN POSITION INDICATOR
*
* PUT PEN UP ROUTINE
PEN3\LDA\PENP\PEN POSITION INDICATOR
\SNZ\\IS IT ZERO?
\JMP\CFOF\YES, GO GET INDICATOR PARAMETER
\SKS\SKNB\BUSY
\JMP\*-1\WAIT UNTIL NOT BUSY
\OCP\PNUP\PUT PEN UP
\CRA\\INDICATE PEN UP
PENC\STA\PENP\SET PEN POSITION INDICATOR
*
CFOF\LDA\IC\PEN POSITION INDICATOR PARAMETER
\SPL\\IS IT NEGATIVE?
\TCA\\YES, MAKE IT POSITIVE
\SUB\=10
\SPL\\IS IC>10?
\JMP\NOFF\NO, NO OFFSET
*
* OFFSET ROUTINE
* OFFSET X  X=(X-XMIN)/XFAC
OFST\LDA\XFLT+1\FLOATING POINT X VALUE - WORD B
\IAB
\LDA\XFLT\FLOATING POINT X VALUE - WORD A
\CALL\S$22\FLOATING POINT SUBTRACT
\DAC\XMIN\X FROM OFFSET ENTRY
\CALL\D$22\FLOATING POINT DIVIDE
\DAC\XFAC\X SCALE FACTOR
\STA\XFLT\VALUE OF OFFSET X - WORD A
\IAB
\STA\XFLT+1\VALUE OF OFFSET X - WORD B
*
* OFFSET Y  Y=(Y-YMIN)/YFAC
\LDA\YFLT+1\FLOATING POINT Y VALUE - WORD B
\IAB
\LDA\YFLT\FLOATING POINT Y VALUE - WORD A
\CALL\S$22\FLOATING POINT SUBTRACT
\DAC\YMIN\Y FROM OFFSET ENTRY
\CALL\D$22\FLOATING POINT DIVIDE
\DAC\YFAC\Y SCALE FACTOR
\STA\YFLT\VALUE OF OFFSET Y - WORD A
\IAB
\STA\YFLT+1\VALUE OF OFFSET Y - WORD B
*
* NO OFFSET ACTION
* CONVERT X TO FIXED POINT VALUE   IX=X*SFCT
NOFF\LDA\XFLT+1\FLOATING POINT X VALUE - WORD B
\IAB
\LDA\XFLT\FLOATING POINT X VALUF - WORD A
\CALL\M$22\FLOATING POINT MULTIPLY
\DAC\SFCT\SCALE FACTOR
\CALL\C$21\FLOATING POINT TO FIXED POINT
\STA\IX\FIXED POINT VALUE OF X
*
* CONVERT Y TO FIXED POINT VALUE   IY=Y*SFCT
\LDA\YFLT+1\FLOATING POINT Y VALUE - WORD B
\IAB
\LDA\YFLT\FLOATING POINT Y VALUE - WORD A
\CALL\M$22\FLOATING POINT MULTIPLY
\DAC\SFCT\SCALE FACTOR
\CALL\C$21\FLOATING POINT TO FIXED POINT
\STA\IY\FIXED POINT VALUE OF Y
*
* CALCULATE CHANGE IN PEN POSITION FROM PREVIOUS POSITION
* CHANGE IN X POSITION   IDLX=ABS(IX-IPNX)
\LDA\IX\FIXED POINT VALUE OF X
\SUB\IPNX\PREVIOUS PEN POSITION
\STA\DLTX\DELTA X
\SPL\\IS IT NEGATIVE?
\TCA\\YES, MAKE IT POSITIVE
\STA\IDLX\ABSOLUTE DELTA X
*
* CHANGE IN Y POSITION   IDLY=ABS(IY-IPNY)
\LDA\IY\FIXED POINT VALUE OF Y
\SUB\IPNY\PREVIOUS PEN POSITION
\STA\DLTY\DELTA Y
\SPL\\IS IT NEGATIVE?
\TCA\\YES, MAKE IT POSITIVE
\STA\IDLY\ABSOLUTE DELTA Y
*
* TEST FOR DIRECTION AND METHOD OF PEN MOTION
* IS THERE MOTION IN THE X DIRECTION?
\LDA\DLTX\DELTA X
\SNZ\\IS IT ZERO?
\JMP\XPL3\YES, GO STORE X DIRECTION
\SMI\\NO, IS IT NEGATIVE?
\JMP\XPL2\NO, MUST BE POSITIVE
\LDA\='200\YES, NEGATIVE X MOTION
\JMP\XPLX\GO STORE X DIRECTION
XPL3\CRA\\NO X MOTION
\JMP\XPLX\GO STORE X DIRECTION
XPL2\LDA\='100\POSITIVE X MOTION
XPLX\STA\XPLT\STORE X DIRECTION
*
* IS THERE MOTION IN THE Y DIRECTION?
XPLA\LDA\DLTY\DELTA Y
\SNZ\\IS IT ZERO?
\JMP\YPL3\YES, GO STORE Y DIRECTION
\SMI\\NO, IS IT NEGATIVE
\JMP\YPL1\NO, MUST BE POSITIVE
\LDA\='1000\YES. NEGATIVE Y MOTION
\JMP\YPLY\GO STORE Y DIRECTION
YPL3\CRA\\NO Y MOTION
\JMP\YPLY\GO STORE Y DIRECTION
YPL1\LDA\='400\POSITIVE Y MOTION
YPLY\STA\YPLT\STORE Y DIRECTION
*
* TEST FOR A COMBINATION MOVE   YPLT+XPLT=XYPL
YPLA\ADD\XPLT\X DIRECTION
\STA\XYPL\COMBINATION MOVE
\SNZ\\IS IT ZERO
\JMP\EXIT\YES, NO MOTION
\LDA\IDLX\ABSOLUTE DELTA X
\CAS\IDLY\COMPARE WITH ABSOLUTE DELTA Y
\NOP\\IDLX>IDLY, NO ACTION
\JMP\NORM\IDLX=IDLY
\IAB\\IDLX<IDLY, PUT X VALUE IN B-REGISTER
*
* MAKE DECISION ON TYPE OF MOVE
* SWAP X AND Y VALUES WITH EACH OTHER
\LDA\IDLY\DELTA Y
\STA\IDLX\PUT Y VALUE IN PLACE OF X VALUE
\IAB\\BRING BACK X VALUE
\STA\IDLY\PUT IT IN PLACE OF Y VALUE
\LDA\YPLT\Y DIRECTION
\STA\XPLT\PUT IT IN PLACE OF X DIRECTION
*
* EQUAL X AND Y MOVE
NORM\LDA\IDLX\ABSOLUTE DELTA X
\ALS\1\MULTIPLY BY TWO
\STA\TDX\TDX=IDLX*2
\LDA\IDLY\ABSOLUTE DELTA Y
\ALS\1\MULTIPLY BY TWO
\STA\TDY\TDY=IDLY*2
\CRA\\CLEAR A-REGISTER
\STA\TEMP\TEMPORARY
\STA\N\NUMBER OF STEPS
*
TENT\LDX\=-10\INDEX REGISTER:-10
OUTP\LDA\TEMP\TEMPORARY
\ADD\TDY\ADD (2*DELTA Y)
\CAS\IDLX\COMPARE WITH DELTA X
\JMP\L1\DELTA X<TDY
\JMP\BASE\DELTA X=TDY, USE X DIRECTION
\JMP\BASE\DELTA X>TDY, USE X DIRECTION
L1\SUB\TDX\SUBTRACT TDX FROM TDY
\STA\TEMP\TEMPORARY
\LDA\XYPL\USE COMBINATION MOVE
\JMP\EXEC\GO EXECUTE COMBINATION MOVE
*
BASE\STA\TEMP\PUT TDY IN TEMPORARY
\LDA\XPLT\AND PLOT X VALUE
*
* PLOT THE MOVE
EXEC\ADD\OCP\BASIC OCP INSTRUCTION
\STA\EXCM\COMPUTED OCP
\SKS\SKNB\SKIP IF NOT BUSY
\JMP\*-1\WAIT UNTIL NOT BUSY
EXCM\***\**\COMPUTED OCP
\IRS\N\TALLY NUMBER OF STEPS
\LDA\N\NUMBER OF STEPS
\CAS\IDLX\DELTA X
\NOP\\N>IDLX. NO ACTION
\JMP\EXIT\EOUAL. MOVE COMPLETED
\IRS\0\TALLY INDEX
\JMP\OUTP\GO FOR NEXT MOVE
\SKS\SKLM\SKIP IF LIMIT NOT REACHED
\JMP\EXIT\LIMIT REACHED. MOVE COMPLETE
\JMP\TENT\GO FOR NEXT MOVE
*
EXIT\LDA\IC\PEN POSITION INDICATOR
\SMI\\SKIP IF END OF PLOT REACHED
\JMP\PLUS\CONTINUE WITH PLOT
*
* END OF PLOT. SET ALL PARAMETERS TO ZERO
TERM\CRA\\END OF PLOT
\LDX\=-10\INDEX REGISTER=-10
L2\STA\XFLT+10,1\ZERO IN PARAMETERS
\IRS\0\TALLY INDEX REGISTER
\JMP\L2\RETURN FOR NEXT PARAMETER
\JMP\PLSA\FINISH PLOT ROUTINE
*
* OBTAIN NEW PEN POSITION COORDINATES
PLUS\LDA\IX\FIXED POINT VALUE OF X
\STA\IPNX\NEW X POSITION
\LDA\IY\FIXED POINT VALUE OF Y
\STA\IPNY\NEW Y POSITION
*
* FINISH PLOT ROUTINE
PLSA\IRS\O$XP\INCREMENT RETURN ADDRESS
\IRS\O$XP\INCREMENT RETURN ADDRESS
\LDX\SAVE\RESTORE INDEX
\JMP*\O$XP\EXIT
*
*
* PROVIDE OFFSET DISTANCES AND SCALE FACTORS
*
O$XO\DAC\**\PROVIDE OFFSET DISTANCES AND SCALE FACTORS
\STX\SAV1\SAVE INDEX
\LDA*\O$XO\ADDRESS OF XMIN
\IRS\O$XO\ADDRESS OF NEXT PARAMETER
\JST\PCUP\PICK UP XMIN
\STA\XMIN\X FROM OFFSET ENTRY - WORD A
\IAB
\STA\XMIN+1\X FROM OFFSET ENTRY - WORD B
\LDA*\O$XO\ADDRESS OF XFAC
\IRS\O$XO\ADDRESS OF NEXT PARAMETER
\JST\PCUP\PICK UP XFAC
\STA\XFAC\SCALE FACTOR FOR X - WORD A
\IAB
\STA\XFAC+1\SCALE FACTOR FOR X - WORD B
*
\LDA*\O$XO\ADDRESS OF YMIN
\IRS\O$XO\ADDRESS OF NEXT PARAMETER
\JST\PCUP\PICK UP YMIN
\STA\YMIN\Y FROM OFFSET ENTRY - WORD A
\IAB
\STA\YMIN+1\Y FROM OFFSET ENTRY - WORD B
\LDA*\O$XO\ADDRESS OF YFAC
\IRS\O$XO\ADDRESS OF END OF PARAMETER LIST
\IRS\O$XO\RETURN ADDRESS
\JST\PCUP\PICK UP YFAC
\STA\YFAC\SCALE FACTOR FOR Y - WORD A
\IAB
\STA\YFAC+1\SCALE FACTOR FOR Y - WORD B
*
\LDX\SAV1\RESTORE INDEX
\JMP*\O$XO\EXIT
*
*
* PROVIDE THE SCALE VALUE FOR BOTH AXES
*
O$XF\DAC\**\PROVIDE SCALE VALUE FOR BOTH AXES
\STX\SAV2\SAVE INDEX
\LDA*\O$XF\SCALE FACTOR ADDRESS
\IRS\O$XF\RETURN ADDRESS
\JST\PCUP\PICK UP SCALE FACTOR
\STA\FACT\FLOATING POINT SCALE FACTOR - WORD A
\IAB
\STA\FACT+1\FLOATING POINT SCALE FACTOR - WORD B
\IAB
\CALL\M$22\FLOATING POINT MULTIPLY
\DAC\FFCT\UNITS CONVERSION FACTOR
\STA\SFCT\CONVERTED SCALE FACTOR - WORD A
\IAB
\STA\SFCT+1\CONVERTED SCALE FACTOR - WORD B
\LDX\SAV2\RESTORE INDEX
\JMP*\O$XF\EXIT
*
*
* REOUEST PRESENT PEN POSITION
*
O$XW\DAC\**\REOUEST PRESENT PEN POSITION
\STX\SAV3\SAVE INDEX
\LDA\XFX+1\X POSITION - WORD B
\IAB
\LDA\XFX\X POSITION - WORD A
\JST\STOR\STORE X POSITION
*
\LDA\YFY+1\Y POSITION - WORD B
\IAB
\LDA\YFY\Y POSITION - WORD A
\JST\STOR\STORE Y POSITION
*
\LDA\FACT+1\SCALE VALUE - WORD B
\IAB
\LDA\FACT\SCALE VALUE - WORD A
\JST\STOR\STORE SCALE VALUE
\LDX\SAV3\RESTORE INDEX
\IRS\O$XW\RETURN ADDRESS
\JMP*\O$XW\EXIT
*
*
* SET PEN AT ORIGIN
*
O$XG\DAC\**\SET PEN AT ORIGIN
\CRA\\CLEAR A-REGISTER
\LDX\=-10\INDEX REGISTER=-10
LABL\STA\XFLT+10,1\PUT ZERO IN PARAMETER LOCATIONS
\IRS\0\TALLY INDEX REGISTER
\JMP\LABL\RETURN FOR NEXT PARAMETER
*
* MOVE PEN AS FAR WEST AS POSSIBLE
\JST\O$XP\PLOT A LINE
\DAC\XPNW\X CO-ORDINATE FOR MOVE WEST
\DAC\YPNW\Y CO-ORDINATE FOR MOVE WEST
\DAC\THRE\PEN UP
\OCT\0\END OF PARAMETER LIST
*
* MOVE PEN EAST TO WITHIN 10 MILLIMETRES OF PAPER EDGE
\JST\O$XP\PLOT A LINES
\DAC\XPNE\X CO-ORDINATE FOR MOVE EAST
\DAC\YPNE\Y CO-ORDINATE FOR MOVE EAST
\DAC\MTHR\PEN UP AND TERMINATE PLOT
\OCT\0\END OF PARAMETER LIST
\JMP*\O$XG\EXIT
*
*
* SUBROUTINES
*
* PICK UP A VARIABLE
PCUP\DAC\**\PICK UP A VARIABLE
\STA\L3\ADDRESS OF VARIABLE
\CALL\L$22\SINGLE PRECISION LOAD
L3\***\**\ADDRESS OF VARIABLE
\JMP*\PCUP\EXIT
*
* STORE A VARIABLE
STOR\DAC\**\STORE A VARIABLE
\STA\SAV4\SAVE INDEX
\LDA*\O$XW\ADDRESS OF PEN POSITIONING ENTRY
\IRS\O$XW\NEXT PEN POSITIONING ENTRY ADDRESS
\STA\L4\STORE ADDRESS
\LDA\SAV4\RESTORE INDEX
\CALL\H$22\SINGLE PRECISION HOLD
L4\***\**\PEN POSITIONING ENTRY ADDRESS
\JMP*\STOR\EXIT
*
* VARIABLES
*
SAVE\BSZ\1\PLOT ROUTINE INDEX
SAV1\BSZ\1\OFFSET ROUTINE INDEX
SAV2\BSZ\1\FACTOR ROUTINE INDEX
SAV3\BSZ\1\POSITIONING ROUTINE INDEX
SAV4\BSZ\1\STORE ROUTINE INDEX
*
XFLT\BSZ\2\FLOATING POINT X VALUE
YFLT\BSZ\2\FLOATING POINT Y VALUE
*
IPNX\BSZ\1\PREVIOUS PEN POSITION
IPNY\BSZ\1\PREVIOUS PEN POSITION
XFX\BSZ\2\FLOATING POINT X POSITION
YFY\BSZ\2\FLOATING POINT Y POSITION
*
IC\BSZ\1\PEN CONTROL PARAMETER
IP\BSZ\1\ABSOLUTE PEN CONTROL PARAMETER
PENP\BSZ\1\PEN POSITION INDICATOR
*
XMIN\BSZ\2\X FROM OFFSET ENTRY
YMIN\BSZ\2\Y FROM OFFSET ENTRY
XFAC\BSZ\2\FLOATING POINT X SCALE
YFAC\BSZ\2\FLOATING POINT Y SCALE
*
IX\BSZ\1\FIXED POINT X VALUE
IY\BSZ\1\FIXED POINT Y VALUE
TEMP\BSZ\1\TEMPORARY STORE
DLTX\BSZ\1\DELTA X
DLTY\BSZ\1\DELTA Y
IDLX\BSZ\1\ABSOLUTE DELTA X
IDLY\BSZ\1\ABSOLUTE DELTA Y
XPLT\BSZ\1\X DIRECTION
YPLT\BSZ\1\Y DIRECTION
XYPL\BSZ\1\COMBINATION MOVE
TDX\BSZ\1\2*DELTA X
TDY\BSZ\1\2*DELTA Y
N\BSZ\1\COUNTER
*
*
* CONSTANTS
*
OCP\OCP\DADP\BASIC OCP INSTRUCTION
PNER\OCT\2\PEN ERROR
FACT\DEC\1.0\FLOATING POINT SCALE VALUE
SFCT\DEC\10.0\STARTING SCALE VALUE
FFCT\DEC\10.0\UNITS CONVERSION FACTOR
XPNW\DEC\-350.0\X CO-ORDINATE FOR MOVE PEN WEST
YPNW\DEC\0.0\Y CO-OROINATE FOR MOVE WEST
XPNE\DEC\-340.0\X CO-ORDINATE FOR MOVE PEN EAST
YPNE\DEC\0.0\Y CO-ORDINATE FOR MOVE EAST
THRE\OCT\3\PEN UP
MTHR\OCT\-3\PEN UP AND TERMINATE PLOT
*
* LITERALS
\FIN\\LITERALS
\END\\END OF O$XP 21.JAN.70 P.G.WHONE

